/*
hgetbits(N) rewritten.
Hendrik Pagenhardt (pagenhar@sunpool.cs.uni-magdeburg.de)
Moved hputbuf to bit_res.h for inline

Last modified: 05/07/97
*/

#include <stdio.h>
#include <limits.h>

#include "bit_res.h"

Bit_Reserve::Bit_Reserve ()
{
  offset = totbit = 0;
  buf = new unsigned int[BUFSIZE];
// ####
  putmask = new int [1 + sizeof(unsigned int) * 8];
  putmask[0] = 0x000;
  putmask[1] = 0x001;
  for ( int i = 2; i <= sizeof(unsigned int) * 8; i++)
	putmask[i] = (putmask[i - 1] << 1) | 1;
}

Bit_Reserve::~Bit_Reserve ()
{
  delete [] putmask;
  delete [] buf;
}

/*read N bit from the bit stream */
unsigned int Bit_Reserve::hgetbits(int N)
{
  if (N > sizeof(unsigned int) * 8) {
	totbit += N;
	return(UINT_MAX);
  }
  
  // BUFSIZE = 4096 = 2^12, so buf_byte_idx%BUFSIZE == buf_byte_idx & 0xfff
  register unsigned long buf_bit_idx = 8 - (totbit & 7), buf_byte_idx = totbit >> 3;
  totbit += N;
  register long j = N;
  if ((j -= buf_bit_idx) <= 0) {
	return((buf[buf_byte_idx & 0xfff] >> -j) & putmask[N]);
  } else {
	register unsigned long val = buf[buf_byte_idx++ & 0xfff] << j;
	for (;;) {
		if ((j -= 8) <= 0) {
			return((val | (buf[buf_byte_idx & 0xfff] >> -j)) & putmask[N]);
		} else {
			val |= buf[buf_byte_idx++ & 0xfff] << j;
		}
	}
  }
}

/*write 8 bits into the bit stream */
// #### moved to bit_res.h
/*
void Bit_Reserve::hputbuf(unsigned int val)
{
  buf[offset & 0xfff] = val;
  offset++;
}
*/

void Bit_Reserve::rewindNbits(int N)
{
  totbit -= N;
}

void Bit_Reserve::rewindNbytes(int N)
{
  totbit -= (N << 3);
}
