/*
New function hgetbit implemented, which is optimized for
returning 1 bit from the stream.
Fiddled a bit with hgetbit until GCC generated more optimal code. (05/07/97)
Moved hputbuf to inline.
Hendrik Pagenhardt (pagenhar@sunpool.cs.uni-magdeburg.de)

Last modified: 05/07/97
*/
#ifndef BIT_RES_H
#define BIT_RES_H

#define BUFSIZE 4096

class Bit_Reserve {

private:

  unsigned int offset, totbit;
  unsigned int *buf;
  int *putmask;

public:

  Bit_Reserve();
  ~Bit_Reserve();

  unsigned int hsstell() { return(totbit); }
  unsigned int hgetbits(int N);

/*read 1 bit from the bit stream */
inline unsigned int Bit_Reserve::hgetbit()
{
  unsigned long b = buf[(totbit >> 3) & 0xfff];
  return((b >> ((-(totbit = totbit + 1)) & 7)) & 1);
}

inline void Bit_Reserve::hputbuf(unsigned int val)
{
  buf[offset++ & 0xfff] = val;
}

// ####  void hputbuf(unsigned int val);

  void rewindNbits(int N);
  void rewindNbytes(int N);
};

#endif
